<?php

namespace Ems\Controllers;

use Ems\Services\GupyService;
use Ems\Util\ExpectedException;
use Zeedhi\Framework\DTO\{ Request, Response };
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;

class GupyController {
    /** @var GupyService */
    protected $gupyService;

    public function __construct(
        GupyService $gupyService
    ) {
        $this->gupyService = $gupyService;
    }

    public function gupyPreEmployeeMoved(
        Request $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();
            $this->gupyService->gupyPreEmployeeMoved($row);
        } catch (ExpectedException $e) {
            $response->addMessage(new Message($e->getMessage(), Message::TYPE_ERROR));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
}